<?
/*
*******************************
 IP-SYMCON Event Scripting
*******************************
File     : Switch_Heizung.ips.php
Trigger  : 
Interval : 
*/

// Variablen
$_ldebug = false;
$Pos_dropValue = 6.0; // Pos-Wert fr Abschaltung
$Pos_exceedValue = 10.0; // Pos-Wert fr Aktivierung  >> Hysterese beachten!!!

// Semaphore mit Devicenamen setzen, verhindert erneuten Aufruf mit gleicher Variable
if (!IPS_SemaphoreEnter("Switch_Heizung_run",100))
{
   echo ("#### Script Switch_Heizung is running yet! ####");
   return;
}

// Ermitteln ob Aufruf durch Variable
if ($IPS_SENDER == "Variable")
{
   $DevName = substr(IPS_GetName($IPS_VARIABLE), 0, 9); // Device FHT aus Variable extrahieren
   if ($_ldebug)
	{
		echo "\n\r";
		echo ("## IPS_Variable: ".$IPS_VARIABLE." ##\n\r");
		echo ("## Device: ".$DevName." ##\n\r");
	}

   if (IPS_GetName($IPS_VARIABLE) == $DevName."_state_r")
      $state = GetValueFloat($DevName."_state_r"); // angeforderter Sollwert
   else
      $state = GetValueFloat($DevName."_state"); // eingestellter Sollwert
}
else
   return;

// prfen der Temp Werte (_ist , _state und trend)
$ist_in = GetValueFloat($DevName."_ist"); // aktueller Wert innen
$ist_out = GetValueFloat("vKS300_Temperatur_recent"); // aktueller Wert auen
$trend_in = GetValueFloat($DevName."_trend"); // Trend Wert innen
$trend_out = GetValueFloat("vKS300_Temperatur_trend"); // Trend Wert auen

if ($_ldebug)
{
   echo "\n\r*#*#*#*#+++ ist_in: ".$ist_in." +++#*#*#*#*\n\r";
   echo "\n\r*#*#*#*#+++ recent_out: ".$ist_out." +++#*#*#*#*\n\r";
   echo "\n\r*#*#*#*#+++ trend_in: ".$trend_in." +++#*#*#*#*\n\r";
   echo "\n\r*#*#*#*#+++ trend_out: ".$trend_out." +++#*#*#*#*\n\r";
   echo "\n\r*#*#*#*#+++ state: ".$state." +++#*#*#*#*\n\r";
}

// Regeldifferenz und Auentemp-diff bestimmen
$regeldiff = $state - $ist_in;      // positiv wenn Temp im Raum ausreichend
$out_in_diff = $state - $ist_out; // Unterschied Innen- / Auentemp

if ($_ldebug) echo "\n\r*#*#*#*#+++ regeldiff: ".$regeldiff." +++#*#*#*#*\n\r";
if ($_ldebug) echo "\n\r*#*#*#*#+++ out_in_diff: ".$out_in_diff." +++#*#*#*#*\n\r";

// Parameterblock
$par1 = 1.8;    // Trend_innen
$par2 = 0.06;   // Diff innen auen linear alt: 0.08
$par3 = 0.12;  // Temp_auen
$par4 = 0.5;    // Trend_auen
$par5 = 0.00015; // Diff innen auen quadratisch
$par6 = 5;      // Wirkung Regel Parameter

// Regelgleichung
$regel_parameter = ( -$trend_in*$par1
                     + $out_in_diff*$par2
                     - $ist_out*$par3
                     - $trend_out*$par4)
                        /$par6;
if ($_ldebug) echo "\n\r*#*#*#*#+++ Regelparameter: ".$regel_parameter." +++#*#*#*#*\n\r";
$Regelwert = ($regeldiff + $out_in_diff *$out_in_diff * $par5) + $regel_parameter;
echo "\n\r*#*#*#*#+++ Regelwert fr ". $DevName .": ".$Regelwert." +++#*#*#*#*\n\r";

// Auswertung
$pos = GetValueFloat($DevName."_pos");
$heat = GetValueBoolean($DevName."_heater");
if (($Regelwert > 0) && ($heat == false) && ($pos > $Pos_exceedValue))
{
   SetValueBoolean($DevName."_heater", true);
}
elseif ((($Regelwert < -0.35) || ($pos < $Pos_dropValue)) && ($heat == true))
{
   SetValueBoolean($DevName."_heater", false);
}



IPS_SemaphoreLeave("Switch_Heizung_run");

?>